importPackage(Packages.com.tivoli.am.fim.trustserver.sts.oauth20);
importPackage(Packages.com.tivoli.am.fim.trustserver.sts.uuser);
importClass(Packages.com.tivoli.am.fim.trustserver.sts.utilities.IDMappingExtUtils);
importClass(Packages.com.tivoli.am.fim.trustserver.sts.utilities.OAuthMappingExtUtils);

var request_type;
var access_token_id = null;
var grant_type = stsuu.getContextAttributes().getAttributeValueByName("grant_type");
var state_id = stsuu.getContextAttributes().getAttributeValueByName("state_id");
var request_type = stsuu.getContextAttributes().getAttributeValueByName("request_type");
var smartcard_id = stsuu.getContextAttributes().getAttributeValueByNameAndType("smartcard_id", "urn:ibm:names:ITFIM:oauth:body:param");

var entireRuleEnabled = false;
if (entireRuleEnabled) {

// how we obtain the username is based on the request_type and grant_type 
var username = null;
if (request_type != null && request_type.equals("authorization")) {
    // browser user-present flow (implicit, azncode). The username should be in an oauth request attribute.
    username = stsuu.getContextAttributes().getAttributeValueByNameAndType(
	"username", "urn:ibm:names:ITFIM:oauth:request");
} else if (request_type != null && request_type.equals("access_token")) {
    // request to token endpoint
    if (grant_type != null && grant_type.equals("password")) {
	// ropc flow - it comes in a post param
	username = stsuu.getContextAttributes().getAttributeValueByNameAndType(
	    "username", "urn:ibm:names:ITFIM:oauth:body:param");
    } else if (grant_type != null && grant_type.equals("client_credentials")) {
	// for client credentials, set the username to the client id
	username = stsuu.getContextAttributes().getAttributeValueByNameAndType(
	    "client_id", "urn:ibm:names:ITFIM:oauth:body:param");
    } 
}

// only evaluate the flow if we're not interested
if (request_type.equals("access_token")) {

IDMappingExtUtils.traceString("the mapping rule is interested");

IDMappingExtUtils.traceString("the mapping rule knows about username: " + username);
IDMappingExtUtils.traceString("the mapping rule knows about smartcard_id: " + smartcard_id);

// if we got a username, associate it with state_id
if (username != null) {
 OAuthMappingExtUtils.associate(state_id, "username", username);
}

function generateCustomAccessTokenString() {
    var username = OAuthMappingExtUtils.getAssociation(state_id, "username");
    if (smartcard_id == null) { smartcard_id = "UNKNOWN"; }
    return "custom_token_" + smartcard_id;
}

// determine if we have an access token to replace in the current response
// if we do, delete the existing access token from the database, and replace
// the value in the response with our custom token
temp_attr = stsuu.getContextAttributes().getAttributeValuesByNameAndType(
    "access_token_id", "urn:ibm:names:ITFIM:oauth:response:metadata");
if (temp_attr != null && temp_attr.length > 0) {
    access_token_id = temp_attr[0];
}
IDMappingExtUtils.traceString("access_token_id: " + access_token_id);

if (access_token_id != null) {
    var custom_token = generateCustomAccessTokenString();

    // OAuthMappingExtUtils.associate(state_id, "access_token", custom_token);
    // OAuthMappingExtUtils.deleteToken(access_token_id);

    var tokens = OAuthMappingExtUtils.getTokens(state_id);
    IDMappingExtUtils.traceString("tokens: "); 
    for (var i = 0; i < tokens.length; i++) {
	IDMappingExtUtils.traceString(tokens[i].getId()); 
    }

    // look up associated keys for this grant
    var associations = OAuthMappingExtUtils.getAssociationKeys(state_id);
    IDMappingExtUtils.traceString("associations with grant " + state_id + ":");
    for (var i = 0; i < associations.length; i++) {
	var key = associations[i];
	var value = OAuthMappingExtUtils.getAssociation(state_id, key);
	IDMappingExtUtils.traceString(key + ": " + value); 
    }


    // replace the existing access token that's going to be sent to the client with our custom access token
    stsuu.getContextAttributes().removeAttributeByNameAndType(
        "access_token", "urn:ibm:names:ITFIM:oauth:response:attribute");
    var attr = new com.tivoli.am.fim.trustserver.sts.uuser.Attribute(
        "access_token", 
        "urn:ibm:names:ITFIM:oauth:response:attribute", 
        custom_token);

    // var is_updated = OAuthMappingExtUtils.updateToken(access_token_id, new_lifetime, null, null);

    stsuu.getContextAttributes().setAttribute(attr);
}
} else {
IDMappingExtUtils.traceString("the mapping rule is skipping evaluation (not interested)");
}
} else {
IDMappingExtUtils.traceString("the post mapping rule is skipping evaluation (disabled)");
}
