/*
 * Component Name: isamTokenAuthenticationLibrary
 * File Name: isamTokenAuthApi.h
 *
 * IBM Confidential
 * Object Code Only Source Materials
 * 5747-SM3
 * (c) Copyright International Business Machines Corp. 2018
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 */

#ifndef _ISAM_TOKEN_AUTH_API_H_
#define _ISAM_TOKEN_AUTH_API_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdarg.h>
#include <stdbool.h>

#include "isamTokenAuthRestApi.h"
#include "isamTokenAuthUtils.h"
#include "isamTokenAuthExterns.h"

#if defined _WIN32 || _WIN64

#define strcpy(str1, str2)\
	do {\
		strcpy_s(str1,strlen(str2),str2);\
	} while (0);

#define strcat(str1,str2) strcat_s(str1,strlen(str2),str2)
#define strncat(str1,str2,integer) strncat_s(str1,MAX_PARAM_SIZE,str2,integer)
#define strtok(str1,str2) strtok_s(str1,str2,&nextToken)
#define strcasecmp strcmp
#define strdup _strdup
#define strncpy(str1,str2,integer) strncpy_s(str1,strlen(str2)+1,str2,integer)
#endif


int authenticateTokenWithNoUserCreds(const char *scopes, const char *token,
		char **errorDescription);
int authenticateTokenWithPassword(const char* password, const char *scopes,
		const char *token, char **errorDescription);
int registerTokenWithUserCreds(const char *username, const char* password,
		const char *scopes, const char *token, char **errorDescription);

void freeParams(char **newParams, const int newParamsCount);
char* findErrorReason(const char *errorResult);
int errorCodeReturn(char *errorDescription);
char** getParams(int *paramsCount, int grantType, const char *token,
		const char *username, const char *password);

enum _grantTypes {
	REGISTER_TOKEN,
	REFRESH_TOKEN
} grantTypes;

#endif /*_ISAM_TOKEN_AUTH_API_H_*/
