/*
 * Component Name: isamTokenAuthenticationLibrary
 * File Name: isamTokenAuthUtils.c
 *
 * IBM Confidential
 * Object Code Only Source Materials
 * 5747-SM3
 * (c) Copyright International Business Machines Corp. 2018
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 */
#ifndef _ISAM_TOKEN_AUTH_UTILS_H_
#define _ISAM_TOKEN_AUTH_UTILS_H_

#include <stdarg.h>
#include "isamTokenAuthApi.h"

extern char* create_full_endpoint_url(const char *hostname, const int port,
		const char *endpoint);
extern int check_url(const char *hostname);
extern void printParams(const char **value, const int count);
extern int as_printf(char **dest, const char *fmt, ...);
extern void freeParams(char **newParams, const int newParamsCount);
extern char* getEndpointUrl(const char *hostname, const int port,
		const char *tokenEndpoint, const int isSSL);
extern char* removeSingleQuotes(const char *username);
extern char* getUserAssociatedWithToken(const char *errorDescription);

#endif /* _ISAM_TOKEN_AUTH_UTILS_H_ */
